package latexDraw.parsers.svg.elements.path;

/**
 * Defines the SVGPath closepath segment.<br>
 *<br>
 * This file is part of LaTeXDraw.<br>
 * Copyright (c) 2005-2008 Arnaud BLOUIN<br>
 *<br>
 *  LaTeXDraw is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.<br>
 *<br>
 *  LaTeXDraw is distributed without any warranty; without even the 
 *  implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 *  PURPOSE. See the GNU General Public License for more details.<br>
 *<br>
 * 10/20/07<br>
 * @author Arnaud BLOUIN<br>
 * @version 0.1<br>
 * @since 0.1
 */
public class SVGPathSegClosePath extends SVGPathSeg
{
	/**
	 * The constructor.
	 * @since 0.1
	 */
	public SVGPathSegClosePath()
	{
		super(true);
	}

	
	@Override
	public String toString()
	{
		return "z";//$NON-NLS-1$
	}
	
	@Override
	public PathSeg getType()
	{
		return PathSeg.CLOSEPATH;
	}
}
